#include "sinewave.h"
#include "ui_sinewave.h"
#include "multilthread.h"
 #include <QtGui>
#include <QPalette>
#include <cmath>
#include <QPainterPath>
#include <QPainter>
#include <QThread>
#include <QDebug>
#include <qvector.h>

  static int i=0;
  static int XStartpoint=0;
  static int YStartpoint=0;
  static int jCount=5;

sinewave::sinewave(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::sinewave)
{
    ui->setupUi(this);
    // code for multithread
    thread = new QThread();
       multithread = new Multithread();

       multithread->moveToThread(thread);
       connect(multithread, SIGNAL(valueChanged(QString)), ui->labelCount, SLOT(setText(QString)));
      connect(multithread, SIGNAL(multithreadRequested()), thread, SLOT(start()));
       connect(thread, SIGNAL(started()), multithread, SLOT(doMultiThraed()));
       connect(multithread, SIGNAL(finished()), thread, SLOT(quit()), Qt::DirectConnection);
       // receive the emited signal
        connect(multithread, SIGNAL(value()),SLOT(display()));
}

sinewave::~sinewave()
{
       multithread->abort();
       thread->wait();
       qDebug()<<this->QObject::thread()->currentThreadId();
       delete thread;
       delete multithread;
      delete ui;
}
void sinewave::changeEvent(QEvent *e)
{
    QMainWindow::changeEvent(e);
      switch (e->type())
      {
      case QEvent::LanguageChange:
          ui->retranslateUi(this);
          break;
      default:
          break;
      }
}
void sinewave::paintEvent(QPaintEvent *pEvent)
{
        QWidget::paintEvent(pEvent);
        QPainter painter(this);
        painter.setRenderHint(QPainter::Antialiasing);
        painter.setPen(Qt::red);
        painter.drawLine(100,200,100,600);
        painter.drawLine(100,400,750,400);

        painter.drawText(630,430,"-> Time X axis");
        painter.drawText(70,250,"^");
        painter.drawText(73,252,"|");
        painter.drawText(80,255,"A");

        //arrows

        painter.drawLine(750,400,740,390);
        painter.drawLine(750,400,740,410);

        painter.drawLine(100,200,110,210);
        painter.drawLine(100,200,90,210);



        QPainterPath wavePath;
        wavePath.moveTo(XStartpoint,YStartpoint);
        qreal tempAmp;

      for(int SS=0;SS<sineCount;SS++)
        {
           QString amp=ui->textEditAmplitude->toPlainText();
           amplitude=amp.toInt();
            tempAmp=amplitude;
            for(int a=1;a<amplitude;a++)
            {

               X1+=time/tempAmp;
                tempAmp--;
                Y1-=1;

                wavePath.lineTo(X1,Y1);
                wavePath.moveTo(X1,Y1);
            }
           tempAmp=1;
            for(int g=amplitude;g>0;g--)
            {
                X1+=time/tempAmp;
                tempAmp++;
                Y1+=1;

                wavePath.lineTo(X1,Y1);
                wavePath.moveTo(X1,Y1);
            }

    // second

          tempAmp=amplitude;
            for(int a=1;a<amplitude;a++)
            {
               X1+=time/tempAmp;
               tempAmp--;
               Y1+=1;

               wavePath.lineTo(X1,Y1);
               wavePath.moveTo(X1,Y1);
            }
            tempAmp=1;
            for(int g=amplitude;g>0;g--)
            {
                X1+=time/tempAmp;
                tempAmp++;
                Y1-=1;

                wavePath.lineTo(X1,Y1);
                wavePath.moveTo(X1,Y1);
            }
         // painter.drawPath(path1);

        }

        painter.drawPath(wavePath);


}
void sinewave::display()
{
    QString amp=ui->textEditAmplitude->toPlainText();
       QString time=ui->textEditTime->toPlainText();
       amplitude=amp.toInt();
       time=time.toInt();
       X1=100.0;
       Y1=400.0;
       XStartpoint=100;
       YStartpoint=400;
       QString lbl=ui->labelCount->text();
       lblCount=lbl.toInt();
       if(lblCount==1)
       {

           sineCount=1;
           repaint();
       }
       else if(lblCount==2)
       {
           sineCount=2;
           repaint();
       }
       if(lblCount==3)
       {
           sineCount=3;
           repaint();
       }
       if(lblCount==4)
       {
           sineCount=4;
           repaint();
       }
       if(lblCount==5)
       {
           sineCount=5;
           repaint();
       }
}

void sinewave::on_pushButtonStart_clicked()
{
    //code to generate sinewave
           amplitude=0.0;
           time=0.0;
           X1=100.0;
           Y1=400.0;
           QString amp=ui->textEditAmplitude->toPlainText();
           QString Ttime=ui->textEditTime->toPlainText();
           amplitude=amp.toInt();
           time=Ttime.toInt();
           XStartpoint=100;
           YStartpoint=400;
           sineCount=5;
           repaint();
}

void sinewave::on_actionStart_triggered()
{
        multithread->abort();
        thread->wait();
        multithread->requestThread();
}

void sinewave::on_actionPause_triggered()
{

}
